# This file was created automatically by SWIG.
import thermalexpansionc
from oof2.SWIG.engine.properties import PropertyPtr
from oof2.SWIG.engine.symmmatrix import SymmMatrix3Ptr
class IsotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsotropicThermalExpansion instance at %s>" % (self.this,)
class IsotropicThermalExpansion(IsotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_IsotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1




class AnisotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C AnisotropicThermalExpansion instance at %s>" % (self.this,)
class AnisotropicThermalExpansion(AnisotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_AnisotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: thermalexpansion.spy,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2005/12/02 19:32:46 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from oof2.SWIG.engine import symmmatrix
from oof2.common import utils
from oof2.common.IO import parameter
from oof2.engine import problem
from oof2.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

PropertyRegistration(
    'Couplings:ThermalExpansion:Isotropic', IsotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",200,
    [parameter.FloatParameter('alpha', 1.0,
                                     tip="Thermal expansion coefficient."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Isotropic thermal expansion')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Triclinic',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",210,
    [symmmatrix.TriclinicRank2TensorParameter('alpha',
                                     symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
                                     tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature. Sometimes referred to as the deposition temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Triclinic thermal expansion')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Monoclinic',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",209,
    [symmmatrix.MonoclinicRank2TensorParameter(
    'alpha',
    symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Monoclinic thermal expansion.')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Orthorhombic',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",208,
    [symmmatrix.OrthorhombicRank2TensorParameter(
    'alpha',
    symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Orthorhombic thermal expansion.')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Tetragonal',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",207,
    [symmmatrix.TetragonalRank2TensorParameter(
    'alpha',
    symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Tetragonal thermal expansion.')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Trigonal',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",206,
    [symmmatrix.TrigonalRank2TensorParameter(
    'alpha',
    symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Trigonal thermal expansion.')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Hexagonal',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",205,
    [symmmatrix.HexagonalRank2TensorParameter(
    'alpha',
    symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Hexagonal thermal expansion.')

PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Cubic',
    AnisotropicThermalExpansion,
    "oof2.SWIG.engine.property.thermalexpansion.thermalexpansion",204,
    [symmmatrix.CubicRank2TensorParameter(
    'alpha',
    symmmatrix.CubicRank2Tensor(xx=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Cubic thermal expansion.')
