# -*- python -*- 
# $RCSfile: DIR.py,v $
# $Revision: 1.17 $
# $Author: langer $
# $Date: 2007/01/08 18:27:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modifed
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

dirname = 'common'
subdirs = ['IO', 'EXTRA']
clib = 'oof2common'
clib_order = 0

cfiles = ['activearea.C', 'coord.C', 'colordifference.C',
'ooferror.C', 'random.C', 'trace.C', 'identification.C',
'timestamp.C', 'switchboard.C', 'swiglib.C', 'pixelgroup.C',
'boolarray.C', 'ccolor.C', 'despeckle.C', 'expandgrp.C', 'bitmask.C',
'cmicrostructure.C', 'cdebug.C', 'pixelattribute.C', 'argv.C',
'lock.C', 'cpixelselection.C', 'brushstyle.C', 'threadstate.C',
'pixelselectioncourier.C', 'intarray.C', 'pixelsetboundary.C']

swigfiles = ['coord.swg', 'colordifference.swg', 'config.swg',
'geometry.swg', 'ooferror.swg', 'space.swg', 'trace.swg',
'switchboard.swg', 'timestamp.swg', 'pixelgroup.swg', 'ccolor.swg',
'boolarray.swg', 'cmicrostructure.swg', 'cdebug.swg', 'argv.swg',
'pixelattribute.swg', 'doublearray.swg', 'lock.swg',
'cpixelselection.swg', 'threadstate.swg', 'brushstyle.swg',
'pixelselectioncourier.swg', 'activearea.swg',
'intarray.swg', 'crandom.swg', 'abstractimage.swg']

pyfiles = ['activeareamod.py', 'backEnd.py', 'color.py',
'cregisteredclass.py', 'debug.py', 'director.py', 'enum.py',
'excepthook.py', 'guitop.py', 'initialize.py', 'labeltree.py',
'mainthread.py', 'microstructure.py', 'object_id.py', 'oof.py',
'oof_getopt.py', 'parallel_enable.py', 'parallel_object_manager.py',
'parallel_performance.py', 'pixelselection.py',
'pixelselectionmethod.py', 'pixelselectionmod.py', 'primitives.py',
'quit.py', 'registeredclass.py', 'ringbuffer.py', 'strfunction.py',
'subthread.py', 'thread_enable.py', 'timer.py', 'toolbox.py',
'utils.py', 'version.py', 'worker.py', 'garbage.py'
'oofversion.py']

swigpyfiles = ['ooferror.spy', 'colordifference.spy', 'coord.spy',
'geometry.spy', 'switchboard.spy', 'space.spy', 'pixelgroup.spy',
'timestamp.spy', 'cdebug.spy', 'brushstyle.spy', 'pixelattribute.spy',
'activearea.spy', 'lock.spy', 'cmicrostructure.spy']


hfiles = ['coord.h', 'colordifference.h', 'geometry.h', 'ooferror.h',
'printvec.h', 'random.h', 'space.h', 'tostring.h', 'trace.h',
'identification.h', 'timestamp.h', 'switchboard.h',
'pythonexportable.h', 'pixelgroup.h', 'removeitem.h', 'swiglib.h',
'array.h', 'ccolor.h', 'boolarray.h', 'bitmask.h', 'cachedvalue.h',
'cmicrostructure.h', 'cdebug.h', 'argv.h', 'pixelattribute.h',
'doublearray.h', 'lock.h', 'cpixelselection.h', 'brushstyle.h',
'pixelselectioncourier.h', 'activearea.h', 'intarray.h',
'pixelsetboundary.h', 'threadstate.h', 'abstractimage.h']


if HAVE_MPI:
    cfiles.extend(['mpitools.C'])
    swigfiles.extend(['mpitools.swg'])
    swigpyfiles.extend(['mpitools.spy'])
    hfiles.extend(['mpitools.h'])

def set_clib_flags(clib):
    if HAVE_MPI:
        clib.externalLibs.append('pmpich++')
        clib.externalLibs.append('mpich')
