# -*- python -*-
# $RCSfile: solvermenuIPC.py,v $
# $Revision: 1.1 $
# $Author: rlua $
# $Date: 2006/05/19 15:05:54 $


# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from oof2.common.IO import parallelmainmenu
from oof2.common.IO import oofmenu
from oof2.common.IO import parameter
from oof2.common.IO import whoville
from oof2.SWIG.engine import solverdriver
from oof2.engine import timedrivers
import oof2.engine.mesh

## OOF.LoadData.IPC.Solver
ipcsolvermenu = parallelmainmenu.ipcmenu.addItem(
    oofmenu.OOFMenuItem('Solver', secret=1, no_log=1)
    )

def parallel_solve(menuitem, mesh, solver):
    meshcontext = oof2.engine.mesh.meshes[mesh] ## a who object
    if meshcontext.getObject().n_active_eqns() == 0:
        raise ooferror.ErrSetupError("There are no active equations!")
    solverProgressBar = menuitem.getProgressBar("continuous") ## actually ran by the worker
    meshcontext.reserve()
    timedriver = timedrivers.Null()
    try:
        try:
            timedriver.apply(solver, meshcontext)
        except ooferror.ErrProcessAborted:
            pass
        ## solved flag is set even if solution did NOT
        ## converge in order to show how far the solution
        ## went.
        meshcontext.solved()
    finally:
        meshcontext.cancel_reservation()


## OOF.LoadData.IPC.Solver.Solve
ipcsolvermenu.addItem(oofmenu.OOFMenuItem(
    'Solve',
    callback = parallel_solve,
    threadable = oofmenu.PARALLEL_THREADABLE,
    params =
    [
    whoville.WhoParameter('mesh', oof2.engine.mesh.meshes,
                          tip=parameter.emptyTipString),
    parameter.RegisteredParameter('solver', solverdriver.Driver,
                                  tip=parameter.emptyTipString)
    ]
    ))
